width = love.graphics.getWidth()
height = love.graphics.getHeight()
xpos, ypos = width/2, height/2
xvel, yvel = 0, 0
rotation = 0
bounce = 0.01
friction = 1.0085
maxBoost = 5000
boost = 5000
normSpeed = 5
boostSpeed = 10
rotationRate = 1
lRTime = 100
laserReload = 0
laserInitVel = 15
lasers = {}--Each laser is a table containing its position, then its velocity.
laserPew = love.audio.newSource("laserSound2.ogg", "stream")
asteroidAverageReload = 10
asteroidReloadCounter = 0
asteroidSize = 30
asteroids = {}--Each asteroid is a table, containing a table which has the all the points making up the asteroid. Outside the table there is a set of central coordinates, rotation, 2 values for velocity, and one for rotational velocity. Spawned between random intervals.

function love.update()
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()

	if love.keyboard.isDown("up") then
		xvel = math.cos(math.rad(rotation))*normSpeed
		yvel = math.sin(math.rad(rotation))*normSpeed
	end
	if love.keyboard.isDown("down") then
		if boost > 0 then
			xvel = math.cos(math.rad(rotation))*boostSpeed
			yvel = math.sin(math.rad(rotation))*boostSpeed
			boost = boost - 1
			else
			xvel = math.cos(math.rad(rotation))*normSpeed
			yvel = math.sin(math.rad(rotation))*normSpeed
		end
	end
	if love.keyboard.isDown("left") then
		rotation = rotation - rotationRate
	end
	if love.keyboard.isDown("right") then
		rotation = rotation + rotationRate
	end
	if love.keyboard.isDown(" ") then --Making a laser. Once a laser is made, it's given a position and a velocity
		if laserReload <= 0 then
			table.insert(lasers, ({xpos+(math.cos(math.rad(rotation))*10),ypos+(math.sin(math.rad(rotation))*10), math.cos(math.rad(rotation))*laserInitVel, math.sin(math.rad(rotation))*laserInitVel}))
			laserReload = laserReload + lRTime
			laserPew:play()
		end
	end
	--next part is simple collision st00f, temporary
	if xpos-10 <= 0 then
		xvel = xvel * -1 * bounce
		xpos = 10
	end
	if xpos+10 >= width then
		xvel = xvel * -1 * bounce
		xpos = width-10
	end
	if ypos-10 <= 0 then
		yvel = yvel * -1 * bounce
		ypos = 10
	end
	if ypos+10 >= height then
		yvel = yvel * -1 * bounce
		ypos = height-10
	end

	if asteroidReloadCounter <= 0 then--Making asteroids!
		table.insert(asteroids, {{math.random(asteroidSize-5, asteroidSize+5)*math.cos(math.rad(0)), math.random(asteroidSize-5, asteroidSize+5)*math.sin(math.rad(0)), math.random(asteroidSize-5, asteroidSize+5)*math.cos(math.rad(72)), math.random(asteroidSize-5, asteroidSize+5)*math.sin(math.rad(72)), math.random(asteroidSize-5, asteroidSize+5)*math.cos(math.rad(144)), math.random(asteroidSize-5, asteroidSize+5)*math.sin(math.rad(144)), math.random(asteroidSize-5, asteroidSize+5)*math.cos(math.rad(216)), math.random(asteroidSize-5, asteroidSize+5)*math.sin(math.rad(216)), math.random(asteroidSize-5, asteroidSize+5)*math.cos(math.rad(288)), math.random(asteroidSize-5, asteroidSize+5)*math.sin(math.rad(288))}, math.cos(math.rad(math.random(0,360)))*math.sqrt(width^2+height^2), math.sin(math.rad(math.random(0,360)))*math.sqrt(width^2+height^2), math.random(0,360), math.random(-10, 10), math.random(-10, 10), math.random(-10, 10)})
		asteroidReloadCounter = math.random(-10, 10)+asteroidAverageReload
		else
		asteroidReloadCounter = asteroidReloadCounter - 1
	end

	if laserReload > 0 then
		laserReload = laserReload - 1
	end

	for a, b in pairs(lasers) do--Keepin' those lasers moving. If they leave the boundaries, they get deleted.
		b[1] = b[1] + b[3]/10
		b[2] = b[2] + b[4]/10
		if b[1] >= width+10 or b[1] <= 0-10 or b[2] >= height+10 or b[2] <= 0-10 then
			table.remove(lasers, a)
		end
	end

	for a, b in pairs(asteroids) do--Moving the asteroids... Yeah...
		b[2] = b[2] + b[5]/10
		b[3] = b[3] + b[6]/10
		b[4] = b[4] + b[7]/10
		if b[2] >= width+20 or b[2] <= 0-20 or b[3] >= height+20 or b[3] <= 0-20 then
			table.remove(asteroids, a)
		end
	end

	xpos = xpos + xvel/10
	ypos = ypos + yvel/10
	xvel = xvel/friction
	yvel = yvel/friction
end

function love.draw()
	love.graphics.setBackgroundColor(0, 0, 0)
	love.graphics.setColor(255,255,255)
	love.graphics.print("FPS: "..love.timer.getFPS(), 10, 0)--Text stuff from here...
	love.graphics.setColor(255,63,0)
	love.graphics.print("Boost Fuel: "..math.floor(boost/(maxBoost/10)), 10, 100)
	love.graphics.setColor(255,63,255)
	love.graphics.print("Laser Charge: "..10-math.floor(laserReload/(lRTime/10)), 10, 120)--To here...
	love.graphics.push()
	love.graphics.setColor(0,127,255)--From here...
	love.graphics.translate(xpos, ypos)
	love.graphics.rotate(math.rad(rotation+90))
	love.graphics.polygon("fill", 0, -10, 10, 10, 0, 5, -10, 10)
	love.graphics.setColor(255,255,255)
	love.graphics.line(0, 5, 0, -10)--To here, components of the ship are rendered.
	love.graphics.pop()
	love.graphics.setColor(255,63,255)
	for c, d in pairs(lasers) do--Rendering them lasers. Length affected by speed.
		love.graphics.line(d[1]-d[3]/2, d[2]-d[4]/2, d[1]+d[3]/2, d[2]+d[4]/2)
	end
	love.graphics.setColor(128,64,32)
	for c, d in pairs(asteroids) do--Asteroid rendering! ahhhhh yea
		love.graphics.push()
		love.graphics.translate(d[2], d[3])
		love.graphics.rotate(math.rad(d[4]))
		love.graphics.polygon("fill", d[1])
		love.graphics.pop()
	end
end
